//--------------   ------------
robotName = "";	//  
//   ,    
frameset("robotName")
{
	frame("|") { return 1; }
}

RobotGender(0);			//  
serialNumber = 734;		//  
city = "";		//     
MAP_MODE = false;		// true,           
WANDERING_MODE = false;	// true,          
canMoving = false;		//     
//------------------------    ----------------



//-----------------------     ----------------
placeIndex = 0;				//       places

places = array(3,4,5,6,7,8);	//    (   )
basePlace = 2;				//     ,      


startWorkTime = 10*60 + 15;	//      ,    
endWorkTime = 21*60 + 30;	//      ,    
placeStandUpTime = 60;		//  ()         
maxPlaceStandUpTime = 15*60;//  (),       
//------------------------      ---------------


//       
lastCity = city;

//  
include("cities.i");

//     
include("weather.i");
include("currencies.i");

//----------------------  - -------------
include("defrbot-chatbot.i");


//--------------------   ------------------
speechTime = GetTickCount();	//    
subjectMask = 0;				//    .   ,   
hasFace = false;				//   .    "* faceIn"  "* faceOut"
nonfaceHello = false;			//  ,      -,      (,         )
isError = false;				//   (,  )
activeMode = true;				//  (true)   (false) .   -    .   -   
speechEnable = true;			//     .   
lockHello = false;				//  

//      (  )
//            ,   
//   
forceChargeMode = false;

//      (  )
//            ,
//           
forceWorkMode = false;


//    ,  "  "
function GetGoodDay()
{
	var tm = localtime(time());
	var h = tm.hour;
	if (h < 4 || h >=23) return "  ";
	if (h < 11) return " ";
	if (h < 18) return " ";
	return " ";
}


//   true,    
function IsWorkTime()
{
	//   
	tm = localtime(time());
	minutes = tm.hour * 60 + tm.min;

	//   
	return minutes >= startWorkTime && minutes <= endWorkTime;
}



frameset("commands",100)
{
	//     
	frame("* SPEECH")
	{
		print("Speech detected!\n");

		//     .
		//       
		//speechTime = GetTickCount();
	}

	//   
	frame("* faceIn")
	{
		Go(false);
		Wandering(false);
		faceTrigger = true;

		PlaySpeech(" ","",GetGoodDay());
		
		if (!activeMode)
		{
			subjectMask = 0;	//     
			hasFace = true;
		}
		activeMode = true;	
	}
	
	
	//   
	frame("* faceOut")
	{
		hasFace = false;
		nonfaceHello = false;
	}

	frame("* SPEECH OFF")
	{
		//    
		speechEnable = false;
	}

	frame("* SPEECH ON")
	{
		//    
		speechEnable = true;
	}

	//   
	frame("* ACTIVE")
	{
		activeMode = true;
		Go(false);
		Wandering(false);

		if (!hasFace && !nonfaceHello && !isError)
		{
			nonfaceHello = true;
			subjectMask = 0;
			PlaySpeech(" ","",GetGoodDay(), "  ");
		}
			
	}

	frame("* LOCK HEAD")
	{
		LockFaceTrackerHead(true);
	}

	frame("* ULOCK HEAD")
	{
		LockFaceTrackerHead(false);
	}

	//      -  -    
	frame("* beep")
	{
		activeMode = true;
		//-------------  1   -   -----------
		// PlaySpeech(" "," ","  ");
		//-------------   1 -----------------------------------------

		//--------  2   -    ------
		Go(false);

		Head(0,0);
		
		if (!hasFace && !nonfaceHello)
		{
			nonfaceHello = true;
			subjectMask = 0;	//     
			PlaySpeech(""," ", GetGoodDay(), "  ");
		}
		//----------   2 ----------------------------------------------
	}


	frame("<r:robotName>   |IP ")
	frame("<r:robotName>    |IP ")
	{
		var ipList = GetIPAddressList();
		var s = "     ";
		for(var i=0; i < count(ipList); i++)
		{
			if (i>0)
			{
				var n = rand(3);
				if (n==0) s+=".    ";
				else
				if (n==1) s+=".    ";
				else
				s+=".    ";
			}	

			s+=toString(ipList[i][0]) + ", " + toString(ipList[i][1]) + ", " + toString(ipList[i][2]) + ", " + toString(ipList[i][3]);
		}
		PlaySpeech(s);
	}

}



//         
//   true,    .  false,    
function Wait(ms)
{
	while(PlaySpeech()) sync();
	sleep(ms);
	if (RobotSilenceTime() < ms) return false;
	return true;
}


//      
function RobotDialogs()
{
	if (robotDialogCount == 0) return;

	//      rbot-chatbot.i      UI
	//  0 -   .
	//  1....  n -  
	//  n -  ,    ,     
	//       .
	//
	//       subjectMask    1,
	//   .
	//  1, ,        
	

	if (subjectMask == 0)
	{
		//  
		subjectMask|=1;
		RobotDialog(0);
		return;
	}
	else
	{
		//  
		var allMask = (1<<robotDialogCount)-1; //  ,    

		if (subjectMask == allMask)
		{
			//     ,    
			RobotDialog(robotDialogCount-1);
		}
		else
    	for(var i=0; i < robotDialogCount*2; i++)
    	{
  			//     1  
    		var n = rand(1,robotDialogCount);
    		var mask = 1<<n;
    		if (!(subjectMask & mask))
    		{
    			//     ,   ,      
    			subjectMask|=mask;
    			RobotDialog(n);
    			return;
			}
		}
	}
}    			

//---------------------   ----------------
FaceTracker(true, true);	//     
SpeechRecognizion(true);	//   
LockFaceTrackerHead(false);	//   

SetBrowserURL('index.php');

activeModeStartTime = 0;	//       0

//  ,      
Head(10,10);
sleep(100);
Head(0,0);
sleep(1000);

modeRotDir = true;			//   

//  
while(true)
{
    sync();


	//    (   )
	if (activeMode)
	{
		//      ,      
		if (activeModeStartTime == 0)
		{
		    LockFaceTrackerHead(false);
			activeModeStartTime = GetTickCount();
		}

        
        //       ,   
        if ((WANDERING_MODE || MAP_MODE) && !PlaySpeech() && GetTickCount() - activeModeStartTime > 10*60 *1000)
        {
        	activeModeStartTime = GetTickCount() - 9 *60 * 1000;
        	PlaySpeech("   ","     ",",    ");
        	Head(0);

        	//     ,   ,    
        	SetWheelSpeed(0, modeRotDir ? 30 : -30);
        	modeRotDir=!modeRotDir;
        	sleep(1000);
        	SetWheelSpeed(0);

        	//   ,     
        	if (!IsFace())
        	{
				activeMode = false;
				subjectMask = 0;
				nonfaceHello = false;
        	}
        }


		//   - ,     	
		if (PlaySpeech()) speechTime = GetTickCount();


		//  n   ...
		if (GetTickCount() - speechTime > 13000)
		{
			speechTime = GetTickCount()+rand(8000);
			if (hasFace)	//   ,    
				RobotDialogs();
			else
			{
				//   ,   
				lastGender = -1;
				lastPerson = '';
				lastAge = -1;
				subjectMask = 0;
				activeMode = false;
				nonfaceHello = false;
			}	
		}

		//   .  (     ),     
		if (Wandering()) activeMode = false;
	}

	
	if (!activeMode)
	{
    	//    
    	activeModeStartTime = 0;
    	

    	if ((canMoving && WANDERING_MODE) || Wandering())	//    ,    
    	{
    		PlaySpeech(", -  ","   ");
    		Wandering(true);

    		//   ,      
    		speechTime = GetTickCount();
    		activeMode = false;
    		while(!activeMode)
    		{
    			//   - ,     
    			if (PlaySpeech()) speechTime = GetTickCount();

    			if (GetTickCount() - speechTime > 20000 && speechEnable) RobotPrompt();
    			sync();
    		}
    	}
    	else
    	//         (  )
    	if (MAP_MODE && canMoving)
    	{

    		//---------       ----------
    		//   ,     ,    
    		p = places[placeIndex];

    		//   
    		if (!IsWorkTime())
    		{
    			forceChargeMode = false;

    			//    ,    
    			if (!forceWorkMode)
    			{
    				//   ,    
    				if (IsChargeConnected()) continue;

					//         
					p = basePlace;
				}
    		}
    		else
    		{
    			//   

    			//    
    			forceWorkMode = false;
			}


    		//         
    		if (forceChargeMode) p = basePlace;
    		
    		//     ,    -   
    		if (GetBattery()>=0 && GetBattery() < 30) p = basePlace;
    		//--------------        -----------------------------



    		//   
    		if (p == basePlace)
    		{
    			PlaySpeech(", -   ","    ", "     ");
			}
			else
			{
    			PlaySpeech(", -  ","   ");
    		}

    		//  
    		LockFaceTrackerHead(false);
	    	Head(0,-15);

    		//  3 .  ,    "* faceIn"
    		ClearFaceIn(6000);
    		nonfaceHello = false;

    		//     p
    		if (GoToPlace(p))
    		{
    			//       
    			Head(0,0);

    			if (p!=basePlace)
    			{
    				//   ,       
    				placeIndex++;
    				if (placeIndex >= count(places)) placeIndex = 0;
    			}	
    		}
    		else
    		{
    			//      
    			// ,    -      ,
    			//   
    			if (!activeMode)
    			{
    				isError = true;
    				Head(0,0);
    				
    				while(isError)
    				{
    					//   
    					SetBrowserURL('placeerror.php');
    					PlaySpeech(" (G:|)  .  ",
    								" (G:|)  .  ",
    								" .  (G:|)  ",
    								" .  (G:|)",
    								" .  (G:|)",
    								" (G:|).  ");

    					// ,    
    					t = GetTickCount() + rand(12000, 30000);
    					while(isError && t - GetTickCount() > 0)
    					{
    						if (IsChargeConnected())
    						{
    							isError = false;
    							activeMode = true;
    							SetCurrentPlace(chargePlace);
    							break;
    						}
    						sync();
						}
    				}
    				subjectMask = 0;				//    .   ,   
					hasFace = false;				//   .    "* faceIn"  "* faceOut"
					isError = false;				//   (,  )
					activeMode = true;				//  (true)   (false) .   -    .   -   
					speechEnable = true;			//     .   
					lockHello = false;				//  
    				SetBrowserURL('index.php');
    			}
    		}	

    		speechEnable = true;
    		if (!activeMode)
    		{
    			PlaySpeech(" , '  (G:|)"," , '  (G:|)");

    			//    placeStandUpTime    
    			startT = GetTickCount();
    			goAway = false;
    			while(!goAway && !activeMode && GetTickCount() - startT < placeStandUpTime * 1000)
    			{

    				Head(rand(-15,15),rand(-15,10));
    				//  N 
    				t = GetTickCount();
    				while(!goAway && !activeMode && GetTickCount() - t < 12000)
    				{
    					sync();
    					if (PlaySpeech()) t = GetTickCount();
    					if (Wandering()) break;
    				}


    				if (!activeMode)
    				{
    					if (speechEnable)
    						RobotPrompt();		//   
    				}
    			}
    			//       ,
    			//        
    		}
    	}
    	else
    	{
    		// ,      ,   
    		//     
    		speechTime = GetTickCount();
    		activeMode = false;
    		while(!activeMode)
    		{
    			//   - ,     
    			if (PlaySpeech()) speechTime = GetTickCount();

    			if (GetTickCount() - speechTime > 20000 && speechEnable)
    			{
    				Head(rand(-15,15),rand(-10,15));
    				RobotPrompt();
				}
    			sync();
    		}
    	}
    }	
}
