//  ,    
//  API.YANDEX.  "  "
YandexAPIKey = "3bf64d72-7a23-4a42-bade-06f9b4cda82b";



function AsMinus(a)
{
	if (a < 0) return " "+toString(-a);
	return toString(a);
}

weather = null;
weatherTime = 0;
weatherCoords = "";

function GetNormPressure(city)
{
	if (city == "") return array(738,745);
	else
	if (city == "-") return array(760, 765);
	else
	if (city == "") return array(750, 760);
	else
	if (city == "") return array(750, 760);
	else
	if (city == "") return array(733, 740);
	else
		return array(755,765);
}

function GetWeather(coords)
{
	if (weatherCoords == coords && time() - weatherTime < 600) return true;

	if (!IsInternet())
	{
		PlaySpeech("     .   ", "     .    ,   .   ,    ");
		return false;
	}

	PlaySpeech(", ",",  ",", ");

	weather = HttpRequestJSON("https://api.weather.yandex.ru/v1/informers?"+coords, "", "", "X-Yandex-API-Key: "+YandexAPIKey+"\r\n");
	if (!weather)
	{
		PlaySpeech(", .      ",
					" .      ",
					",     ");
		print("*** weather REQUEST ERROR\n");
		return false;
	}

	weatherTime = time();
	weatherCoords = coords;
	return true;
}


function SayWeather(city, coords)
{
	if (!GetWeather(coords)) return;

	var s = "  ,   "+city+",   "+AsMinus(weather.fact.temp)+" "+WordCase(weather.fact.temp, "","","");
	if (abs(weather.fact.temp - weather.fact.feels_like) > 2)
		s+=".    "+AsMinus(weather.fact.feels_like)+" "+WordCase(weather.fact.feels_like, "","","");
	s+=". ";
	if (weather.fact.condition == "clear") s+="";
	else
	if (weather.fact.condition == "partly-cloudy") s+=" ";
	else
	if (weather.fact.condition == "cloudy") s+="  ";
	else
	if (weather.fact.condition == "overcast") s+="";
	else
	if (weather.fact.condition == "partly-cloudy-and-light-rain") s+="  ,   ";
	else
	if (weather.fact.condition == "partly-cloudy-and-rain") s+="  ,   ";
	else
	if (weather.fact.condition == "overcast-and-rain") s+=",  ";
	else
	if (weather.fact.condition == "overcast-thunderstorms-with-rain") s+=",    ";
	else
	if (weather.fact.condition == "cloudy-and-light-rain") s+=",  ";
	else
	if (weather.fact.condition == "overcast-and-light-rain") s+=",  ";
	else
	if (weather.fact.condition == "cloudy-and-rain") s+=",  ";
	else
	if (weather.fact.condition == "overcast-and-wet-snow") s+=",    ";
	else
	if (weather.fact.condition == "partly-cloudy-and-light-snow") s+="  ,  ";
	else
	if (weather.fact.condition == "partly-cloudy-and-snow") s+="  ,  ";
	else
	if (weather.fact.condition == "overcast-and-snow") s+=",  ";
	else
	if (weather.fact.condition == "cloudy-and-light-snow") s+=",  ";
	else
	if (weather.fact.condition == "overcast-and-light-snow") s+=",  ";
	else
	if (weather.fact.condition == "cloudy-and-snow") s+=",  ";

	s+='. ';
	if (weather.fact.wind_dir == "c") s+=" ";
	else
	{
		if (weather.fact.wind_dir == "nw") s+=" -";
		else
		if (weather.fact.wind_dir == "n") s+=" ";
		else
		if (weather.fact.wind_dir == "ne") s+=" -";
		else
		if (weather.fact.wind_dir == "e") s+=" ";
		else
		if (weather.fact.wind_dir == "se") s+=" -";
		else
		if (weather.fact.wind_dir == "s") s+=" ";
		else
		if (weather.fact.wind_dir == "sw") s+=" -";
		else
		if (weather.fact.wind_dir == "w") s+=" ";
	
		s+=", "+toString(toInt(weather.fact.wind_speed))+" "+WordCase(toInt(weather.fact.wind_speed),"  ","  ","  ");
		if (weather.fact.wind_gust > weather.fact.wind_speed+1)
		{
			s+=",   "+NumberToDesc(toInt(weather.fact.wind_gust),".")+" "+WordCase(toInt(weather.fact.wind_gust),"  ","  ","  ");
		}
	}

	s+=". ";

	var act = '';
	if (weather.forecast.parts[0].pressure_mm >= weather.fact.pressure_mm + 2)
		act = ',   ';
	else
	if (weather.forecast.parts[0].pressure_mm <= weather.fact.pressure_mm - 2)
		act = ',   ';




	s+=" "+act+toString(weather.fact.pressure_mm)+" "+WordCase(weather.fact.pressure_mm,"","","")+"  , ";

	var np = GetNormPressure(city);

	if (weather.fact.pressure_mm > np[1]) s+="  ";
	else
	if (weather.fact.pressure_mm < np[0]) s+="  ";
	else
		s+="  ";

	s+=". ";
	s+="   "+toString(weather.fact.humidity)+" "+WordCase(weather.fact.humidity,"","","");

	PlaySpeech(s);

}


function SayWeatherForecast(city, coords)
{
	if (!GetWeather(coords)) return;

	var s = "  ,   "+city+", ";
	
	for(var p=0; p < count(weather.forecast.parts); p++)
	{
		var part = weather.forecast.parts[p];
		if (part.part_name == "morning") s+="  ";
		else
		if (part.part_name == "day") s+="  ";
		else
		if (part.part_name == "evening") s+="  ";
		else
		if (part.part_name == "night") s+="  ";

		if (p==0) s+=DateToDesc(weather.forecast.date_ts,1,false)+" , "; else s+=", ";
		
		s+="  "+AsMinus(part.temp_avg)+" "+WordCase(part.temp_avg, "","","");
		if (abs(part.temp_avg - part.feels_like)>2)
			s+=".     "+AsMinus(part.feels_like)+" "+WordCase(part.feels_like, "","","");
		s+=". ";
		if (part.condition == "clear") s+="";
		else
		if (part.condition == "partly-cloudy") s+=" ";
		else
		if (part.condition == "cloudy") s+="  ";
		else
		if (part.condition == "overcast") s+="";
		else
		if (part.condition == "partly-cloudy-and-light-rain") s+="  ,   ";
		else
		if (part.condition == "partly-cloudy-and-rain") s+="  ,  ";
		else
		if (part.condition == "overcast-and-rain") s+=",  ";
		else
		if (part.condition == "overcast-thunderstorms-with-rain") s+=",     ";
		else
		if (part.condition == "cloudy-and-light-rain") s+=",  ";
		else
		if (part.condition == "overcast-and-light-rain") s+=",  ";
		else
		if (part.condition == "cloudy-and-rain") s+=",  ";
		else
		if (part.condition == "overcast-and-wet-snow") s+=",     ";
		else
		if (part.condition == "partly-cloudy-and-light-snow") s+="  ,  ";
		else
		if (part.condition == "partly-cloudy-and-snow") s+="  ,  ";
		else
		if (part.condition == "overcast-and-snow") s+=",  ";
		else
		if (part.condition == "cloudy-and-light-snow") s+=",  ";
		else
		if (part.condition == "overcast-and-light-snow") s+=",  ";
		else
		if (part.condition == "cloudy-and-snow") s+=",  ";

		s+='. ';

		var np = GetNormPressure(city);
		if (part.pressure_mm <= np[0] - 10) 
			s+="    ,   "+toString(part.pressure_mm)+" "+WordCase(part.pressure_mm,"","","")+"  . ";
		else
		if (part.pressure_mm >= np[1] + 10) 
			s+="    ,   "+toString(part.pressure_mm)+" "+WordCase(part.pressure_mm,"","","")+"  . ";


		if (part.wind_speed > 7 || part.wind_gust > 10)
		{
			s+=" , "+toString(toInt(part.wind_speed))+" "+WordCase(toInt(part.wind_speed),"  ","  ","  ");
			if (part.wind_gust > part.wind_speed+1)
			{
				s+=",   "+NumberToDesc(toInt(part.wind_gust), "..")+" "+WordCase(toInt(part.wind_gust),"  ","  ","  ");
			}
			s+=".";
		}
	}
	PlaySpeech(s);
}



function SayYandexTemperature(city, coords)
{
	if (!GetWeather(coords)) return;

	var s = "  "+city+",   "+AsMinus(weather.fact.temp)+" "+WordCase(weather.fact.temp, "","","");
	if (weather.fact.temp!=weather.fact.feels_like)
		s+=".    "+AsMinus(weather.fact.feels_like)+" "+WordCase(weather.fact.feels_like, "","","");
	PlaySpeech(s);
}

function SayYandexPressure(city, coords)
{
	if (!GetWeather(coords)) return;

	var act = '';
	if (weather.forecast.parts[p].pressure_mm >= weather.fact.pressure_mm + 2)
		act = ',   ';
	else
	if (weather.forecast.parts[p].pressure_mm <= weather.fact.pressure_mm - 2)
		act = ',   ';

	var np = GetNormPressure(city);

	var s = "   "+city+", "+act+toString(weather.fact.pressure_mm)+" "+WordCase(weather.fact.pressure_mm,"","","")+"  , ";
	if (weather.fact.pressure_mm > np[1]) s+="  ";
	else
	if (weather.fact.pressure_mm < np[0]) s+="  ";
	else
		s+="  ";
	PlaySpeech(s);
}


function SayYandexRH(city, coords)
{
	if (!GetWeather(coords)) return;

	var s = "  "+city+",    "+toString(weather.fact.humidity)+" "+WordCase(weather.fact.humidity,"","","");
	PlaySpeech(s);
}

function WeatherDesc(city, coords)
{
	if (!GetWeather(coords)) return;

	if (strpos(weather.fact.condition,"rain")!==null)
	{
		return "  "+city+"  .     .       ";
	}
		
	if (strpos(weather.fact.condition,"show")!==null)
	{
		return "  "+city+"  .   .      ";
	}

	if (weather.fact.condition == "clear" && weather.fact.temp>=32)
	{
		return "  "+city+"    .     ";
	}

	if (weather.fact.temp >=36)
	{
		return "  "+city+"  .   ";
	}

	if (weather.fact.temp < -5)
	{
		return " ,   "+city+"  .       ";
	}

	if (weather.fact.wind_speed >=13)
	{
		return " ,   "+city+"   .        ";
	}

	if (weather.fact.wind_gust >=20)
	{
		return " ,   "+city+"    .        ";
	}
    
	if (weather.fact.humidity >=80)
	{
		return "  "+city+"     ,  "+toString(weather.fact.humidity)+" "+WordCase(weather.fact.humidity, "","","")+".      ";
	}
    return " ,   "+city+", (R: | )";
}


function SayYandexRain(city, coords)
{
	if (!GetWeather(coords)) return;

	var s = "  ,    "+city+", ";
	if (weather.fact.condition == "clear") s+="";
	else
	if (weather.fact.condition == "partly-cloudy") s+=" ";
	else
	if (weather.fact.condition == "cloudy") s+="  ";
	else
	if (weather.fact.condition == "overcast") s+="";
	else
	if (weather.fact.condition == "partly-cloudy-and-light-rain") s+="  ,   ";
	else
	if (weather.fact.condition == "partly-cloudy-and-rain") s+="  ,   ";
	else
	if (weather.fact.condition == "overcast-and-rain") s+=",  ";
	else
	if (weather.fact.condition == "overcast-thunderstorms-with-rain") s+=",    ";
	else
	if (weather.fact.condition == "cloudy-and-light-rain") s+=",  ";
	else
	if (weather.fact.condition == "overcast-and-light-rain") s+=",  ";
	else
	if (weather.fact.condition == "cloudy-and-rain") s+=",  ";
	else
	if (weather.fact.condition == "overcast-and-wet-snow") s+=",    ";
	else
	if (weather.fact.condition == "partly-cloudy-and-light-snow") s+="  ,  ";
	else
	if (weather.fact.condition == "partly-cloudy-and-snow") s+="  ,  ";
	else
	if (weather.fact.condition == "overcast-and-snow") s+=",  ";
	else
	if (weather.fact.condition == "cloudy-and-light-snow") s+=",  ";
	else
	if (weather.fact.condition == "overcast-and-light-snow") s+=",  ";
	else
	if (weather.fact.condition == "cloudy-and-snow") s+=",  ";
	PlaySpeech(s);
}


function SayYandexWind(city, coords)
{
	if (!GetWeather(coords)) return;

	var s = "";
	if (weather.fact.wind_dir == "c") s=" ";
	else
	{
		if (weather.fact.wind_dir == "nw") s=" -";
		else
		if (weather.fact.wind_dir == "n") s=" ";
		else
		if (weather.fact.wind_dir == "ne") s=" -";
		else
		if (weather.fact.wind_dir == "e") s=" ";
		else
		if (weather.fact.wind_dir == "se") s=" -";
		else
		if (weather.fact.wind_dir == "s") s=" ";
		else
		if (weather.fact.wind_dir == "sw") s=" -";
		else
		if (weather.fact.wind_dir == "w") s=" ";
	
		s+=", "+toString(toInt(weather.fact.wind_speed))+" "+WordCase(toInt(weather.fact.wind_speed),"  ","  ","  ");
		if (weather.fact.wind_gust > weather.fact.wind_speed+1)
		{
			s+=",   "+NumberToDesc(toInt(weather.fact.wind_gust),".")+" "+WordCase(toInt(weather.fact.wind_gust),"  ","  ","  ");
		}
	}

	PlaySpeech("  ,    "+city+", "+s);
}

/*
SayWeather();
while(PlaySpeech()) sync();
*/



frameset("weather",1)
{
	frame("  :")
	frame("  :")
	frame("  :")
	{
		LangQuery("    "+city);
	}

	frame("| | :")
	frame("| ||  [] :")
	frame("|  [] :")
	frame("|  :")
	frame("    :")

	frame("|   []")
	frame("| []  || :")
	frame("|  || [] :")
	frame("|  []  |:")
	frame("| |  [] :")

	frame("|  :")
	frame("|    :")
	frame("|    :")
	frame("     :")
	{
		LangQuery("      "+city);
	}


	gLastForecastTime = 0;

	frame("| ||   <city:cities>")
	frame("|  <city:cities> || ")
	frame("| ||  <city:cities> ")
	frame("| ||  []   <city:cities>")
	frame("|  <city:cities> ||  [] ")
	frame("| ||  <city:cities>  [] ")
	frame("| ||   <city:cities> [] ")
	frame("|  ||  <city:cities>")
	frame("|   <city:cities> ||")
	frame("|  <city:cities>  ||")
	frame("|  <city:cities> || ")

	frame("|  []   <city:cities>")
	frame("|   <city:cities> [] ")
	frame("|  <city:cities>  [] ")
	frame("      <city:cities>")
	frame("    <city:cities>  ")

	frame("|   []  <city:cities>")
	frame("|   <city:cities>  []")
	frame("|    <city:cities> ")

	frame("| []  |||   <city:cities>")
	frame("| []  |||  <city:cities> ")
	frame("| []   <city:cities> ||| ")
	frame("|  <city:cities> []  || ")
	frame("|  ||| []   <city:cities>")
	frame("|  ||  <city:cities> [] ")
	frame("|   <city:cities> || [] ")
	frame("|  <city:cities>  || [] ")
	frame("|  []  |  <city:cities>")
	frame("|  []   <city:cities> |")
	frame("|   <city:cities> []  |")
	frame("|  <city:cities>  []  |")
	frame("| ||  []   <city:cities>")
	frame("| |   <city:cities> [] ")
	frame("| |  <city:cities>  [] ")
	frame("|  <city:cities> |  [] ")

	frame("|    <city:cities>")
	frame("|  <city:cities>  ")
	frame("|      <city:cities>")
	frame("|    <city:cities>  ")
	frame("|  <city:cities>    ")
	frame("|      <city:cities>")
	frame("|    <city:cities>  ")
	frame("|  <city:cities>    ")
	frame("       <city:cities>")
	frame("     <city:cities>  ")
	{
		var pair = split("|",ValueOf("city"));
		lastCity = pair[0];
		gLastForecastTime = time();
		SayWeatherForecast(lastCity, pair[1]);
		WeatherTempFrameset();
	}

	frame("   []  ")
	frame("    ")
	frame("   []  ")
	frame("    ")
	frame("     ")
	frame("    ")
	frame("       ")
	{
		if (time() - gLastForecastTime < 200)
		{
			PlaySpeech(" ,      ");
		}
		else
			LangQuery("    ");
	}



	function WeatherTempFrameset()
	{
		while(PlaySpeech()) sync();
		frameset("temp",1)
		{
			frame(" [] :")
			frame(" []   :")
			frame("   [] :")
			frame(" |    :")
			frame("   |  :")
			{
				LangQuery("      "+lastCity);
			}

			frame(" |||  ")
			{
				LangQuery("      ");
			}

			frame(" :")
			frame(" :")
			frame(" :")
			frame(" :")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			{
				LangQuery("   "+lastCity);
			}

			frame(" :")
			frame(" :")
			frame("   :")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			{
				LangQuery("   "+lastCity);
			}

			frame(" :")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame(" :")
			frame("  :")
			{
				LangQuery("   "+lastCity);
			}

			frame(" :")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame("   ")
			frame(" :")
			frame("  ")
			frame(" c  ")
			frame("   ")
			frame("   ")
			{
				LangQuery("    "+lastCity);
			}


			frame(" |||||||:")
			frame("||||||| |:")
			frame("  |||:")
			frame("  |||||||")
			frame("  |||:")
			frame("||| ||:")
			frame("   |||:")
			frame("   |||:")
			frame(" []  |||:")
			frame("  :")
			frame("  :")
			frame(" :")
			frame("- :")
			{
				LangQuery("   "+lastCity);
			}
		}
	}

	frame(" [] :")
	frame("    :")
	frame("  :")
	{
		LangQuery("    "+city);
	}

	frame("    <city:cities>")
	frame("      <city:cities>")
	frame("    <city:cities>")
	{
		var pair = split("|",ValueOf("city"));
		lastCity = pair[0];
		PlaySpeech(WeatherDesc(lastCity, pair[1]));
		WeatherTempFrameset();
	}

	frame(" []   <city:cities>")
	frame("    <city:cities>")
	frame("   <city:cities>")
	frame("    <city:cities>")
	frame("  <city:cities>  ")
	frame("   <city:cities> ")
	frame("    <city:cities>")
	{
		var pair = split("|",ValueOf("city"));
		lastCity = pair[0];
		SayWeather(lastCity, pair[1]);

		WeatherTempFrameset();
	}


	frame("  :")
	frame("  :")
	frame("  :")
	frame("  :")
	{
		LangQuery("   "+city);
	}

	frame("    <city:cities>")
	frame("   <city:cities>")
	frame("    <city:cities>")
	frame("    <city:cities>")
	frame("   <city:cities> ")
	frame("  <city:cities> ")
	frame("    <city:cities>")
	frame("   <city:cities> ")
	frame("  <city:cities>  ")
	{
		var pair = split("|",ValueOf("city"));
		lastCity = pair[0];
		SayYandexTemperature(lastCity, pair[1]);
		WeatherTempFrameset();
	}


	frame("   []")
	frame("    []")
	frame("   ")
	frame("   ")
	frame(" []  [] ")
	{
		LangQuery("    "+city);
	}

	frame("   []  <city:cities>")
	frame("   <city:cities>")
	frame("    <city:cities>")
	frame("  <city:cities> ")
	frame("    <city:cities>")
	frame("   <city:cities> []  []")
	frame("  <city:cities> []  [] ")
	{
		var pair = split("|",ValueOf("city"));
		lastCity = pair[0];
		SayYandexRH(lastCity, pair[1]);
		WeatherTempFrameset();
	}


	frame("  :")
	frame("  :")
	{
		LangQuery("   "+city);
		frameset("temp",1)
		{
			frame("   ")
			{
				LangQuery("   ");
			}
		}
	}

	frame("    <city:cities>")
	frame("   <city:cities>")
	frame("    <city:cities>")
	frame("   <city:cities> ")
	{
		var pair = split("|",ValueOf("city"));
		lastCity = pair[0];
		SayYandexPressure(lastCity, pair[1]);
		WeatherTempFrameset();
	}

	frame("  |")
	frame("  | |")
	frame("  ")
	frame("  ")
	{
		LangQuery("    "+lastCity);
	}

	frame("  | | <city:cities>")
	frame(" | <city:cities>  |")
	frame("| <city:cities>   |")
	frame("  | | | <city:cities>")
	frame("  | | <city:cities> |")
	frame("| <city:cities>   | |")
	frame("   | <city:cities>")
	frame(" | <city:cities>  ")
	frame("| <city:cities>   ")
	frame("   | <city:cities>")
	frame(" | <city:cities>  ")
	frame("| <city:cities>   ")
	{
		var pair = split("|",ValueOf("city"));
		lastCity = pair[0];
		var np = GetNormPressure(lastCity);
		PlaySpeech("     "+lastCity+", "+np[0]+", "+np[1]+" "+WordCase(np[1], "","","")+"  ");
	}

	frame("[ ]  760 |  ")
	frame("[ ]    |")
	frame(" |  [ ] ")
	frame("   | [ ] ")
	frame("  [ ]   |")
	{
		PlaySpeech("              ");
	}


	frame("  ")
	frame("  ")
	frame("   ")
	frame("   ")
	{
		PlaySpeech(" ,  ,  ,  ");
	}

	frame("  ")
	frame("   ")
	frame("  ")
	frame("   ")
	{
		PlaySpeech("         ");
	}

	frame("   ")
	frame("   ")
	frame("   ")
	frame("    ")
	frame("     ||")
	frame("  |  ")
	frame("     || ")
	frame("   | ")
	frame("     ")
	frame("      ")
	frame("     ")
	frame("   ")
	{
		PlaySpeech("           ");
	}

	frame("   |")
	frame("  ")
	frame("  ")
	frame("   ")
	frame("     |||||")
	frame("     |||||")
	frame("    ||||| ")
	{
		PlaySpeech(" ,             .   ,     .         ");
	}

	frame("     & | & |  &  &  |  &  & ")
	{
		PlaySpeech(" ,            .           ");
	}



	frame("  :")
	frame("   ")
	frame("    ")
	frame("    ")
	frame("    ")
	frame("  |")
	frame("|   ")
	frame("|    ")
	frame("  | ")
	frame("   ")
	frame("    ")
	{
		LangQuery("    "+city);
	}


	frame("    <city:cities>")
	frame("   <city:cities>")
	frame("    <city:cities>")
	frame("   <city:cities> ")
	frame("   <city:cities> ")
	{
		var pair = split("|",ValueOf("city"));
		lastCity = pair[0];
		SayYandexWind(lastCity, pair[1]);
		WeatherTempFrameset();
	}


	frame("   ")
	frame("  ")
	frame("   ")
	frame("  ")
	frame("  ")
	frame("   ")
	frame("    ")
	{
		PlaySpeech(" ,      12   ");
	}




	frame("   ")
	frame("|||   ")
	frame("||   ")
	frame("  |||  ")
	frame("|||  ")
	frame("  |||")
	frame("  |||  ")
	frame("   [] ||")
	frame("   || :")
	frame("   ||:")
	frame("   ||  ")
	frame("   ||   ")
	frame("   ||")
	frame("||   ")
	frame("||   ")
	{
		LangQuery("   "+city);
	}

	frame("   <city:cities>")
	frame("    <city:cities>")
	frame("    <city:cities>")
	frame("  ||||||  <city:cities>")
	frame("   <city:cities> [] ||")
	frame(" <city:cities> []  |||")
	frame("  <city:cities>  |||")
	frame("  <city:cities>  |||")
	frame(" <city:cities> []  |||")
	frame("   <city:cities> [] |||")
	{
		var pair = split("|",ValueOf("city"));
		lastCity = pair[0];
		SayYandexRain(lastCity, pair[1]);
		WeatherTempFrameset();
	}

	frame("  |")
	frame("  |")
	{
		PlaySpeech("   .     ");
	}

	frame("  |")
	frame("  |")
	{
		PlaySpeech("  ,     ,      ");
	}
}

frameset("robotweather",1)
{
	frame("<r:robotName> <a:weather>")
	{
		ValueOf("a");
	}
}
